"""
    Bamboo Flexibility API

     This API provides access to flexibility assets managed by Bamboo Energy: - Create and list flexibility sites & assets - Obtain activations for specific assets - Post and get measurements for specific assets   # noqa: E501

    The version of the OpenAPI document: 1.6.2
    Contact: development@bambooenergy.tech
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bambooapi_client.api_client import ApiClient, Endpoint as _Endpoint
from bambooapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from bambooapi_client.model.http400_bad_request import HTTP400BadRequest
from bambooapi_client.model.http401_unauthorized import HTTP401Unauthorized
from bambooapi_client.model.http403_forbidden import HTTP403Forbidden
from bambooapi_client.model.http404_not_found import HTTP404NotFound
from bambooapi_client.model.http_validation_error import HTTPValidationError
from bambooapi_client.model.market import Market
from bambooapi_client.model.market_create import MarketCreate
from bambooapi_client.model.market_list_item import MarketListItem
from bambooapi_client.model.market_update import MarketUpdate


class MarketsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_market_endpoint = _Endpoint(
            settings={
                'response_type': (Market,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/markets',
                'operation_id': 'create_market',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'market_create',
                ],
                'required': [
                    'market_create',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'market_create':
                        (MarketCreate,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'market_create': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_market_endpoint = _Endpoint(
            settings={
                'response_type': (Market,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/markets/{market_id}',
                'operation_id': 'delete_market',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'market_id',
                ],
                'required': [
                    'market_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'market_id',
                ]
            },
            root_map={
                'validations': {
                    ('market_id',): {

                        'inclusive_maximum': 9999,
                        'inclusive_minimum': 1001,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'market_id':
                        (int,),
                },
                'attribute_map': {
                    'market_id': 'market_id',
                },
                'location_map': {
                    'market_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_market_endpoint = _Endpoint(
            settings={
                'response_type': (Market,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/markets/{market_id}',
                'operation_id': 'get_market',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'market_id',
                ],
                'required': [
                    'market_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'market_id',
                ]
            },
            root_map={
                'validations': {
                    ('market_id',): {

                        'inclusive_maximum': 9999,
                        'inclusive_minimum': 1001,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'market_id':
                        (int,),
                },
                'attribute_map': {
                    'market_id': 'market_id',
                },
                'location_map': {
                    'market_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_markets_endpoint = _Endpoint(
            settings={
                'response_type': ([MarketListItem],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/markets',
                'operation_id': 'list_markets',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_market_endpoint = _Endpoint(
            settings={
                'response_type': (Market,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/markets/{market_id}',
                'operation_id': 'update_market',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'market_id',
                    'market_update',
                ],
                'required': [
                    'market_id',
                    'market_update',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'market_id',
                ]
            },
            root_map={
                'validations': {
                    ('market_id',): {

                        'inclusive_maximum': 9999,
                        'inclusive_minimum': 1000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'market_id':
                        (int,),
                    'market_update':
                        (MarketUpdate,),
                },
                'attribute_map': {
                    'market_id': 'market_id',
                },
                'location_map': {
                    'market_id': 'path',
                    'market_update': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_market(
        self,
        market_create,
        **kwargs
    ):
        """Create a Market  # noqa: E501

        Create a Market with all the information:  - **market_name**: A unique name for the market - **market_type**: Type of market. - **country_code**: ISO_3166-1 or ISO_3166-2:ES country code in which the   market operates. - **min_bid_size**: Minimum power (in kW) to offer in a ramp up bid, ramp   down bid or the sum of both. - **product_resolution**: Time (in hours) that a unit has to offer is   flexibility. - **payment mechanism**: Payment mechanism. - **notification_time**: [Only for flexibility markets] Maximum reaction   time (in hours) of the flexibility source. - **symmetry_ratio**: [Only for flexibility markets] Ratio between ramp up   bid offer and ramp down bid offer in symmetrical markets.   In other words, symmetry_ratio = (ramp_up bid) / (ramp_down bid).   Set value to null if the market is not symmetrical. - **capacity_payment**: [Only for flexibility market] If True, we are be   paid just to be available to offer flexibility. - **max_activations**: [Only for flexibility market] Maximum number of   activations. Set value to null if there's no limit in the number of   activations. - **delivery_duration**: [Only for flexibility market] Maximum time (in   hours) an activation lasts. Set null value if there's no time limit.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_market(market_create, async_req=True)
        >>> result = thread.get()

        Args:
            market_create (MarketCreate):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Market
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['market_create'] = \
            market_create
        return self.create_market_endpoint.call_with_http_info(**kwargs)

    def delete_market(
        self,
        market_id,
        **kwargs
    ):
        """Delete a Market  # noqa: E501

        Delete a Market.  **WARNING!: Market deletion is PERMANENT!** (no way to recover deleted Market)  **WARNING!: Deleting a Market does not delete the associated time series prices!**  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_market(market_id, async_req=True)
        >>> result = thread.get()

        Args:
            market_id (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Market
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['market_id'] = \
            market_id
        return self.delete_market_endpoint.call_with_http_info(**kwargs)

    def get_market(
        self,
        market_id,
        **kwargs
    ):
        """Info about a specific Market  # noqa: E501

        Info about a specific Market.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_market(market_id, async_req=True)
        >>> result = thread.get()

        Args:
            market_id (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Market
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['market_id'] = \
            market_id
        return self.get_market_endpoint.call_with_http_info(**kwargs)

    def list_markets(
        self,
        **kwargs
    ):
        """List all Markets  # noqa: E501

        List all Markets.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_markets(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [MarketListItem]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.list_markets_endpoint.call_with_http_info(**kwargs)

    def update_market(
        self,
        market_id,
        market_update,
        **kwargs
    ):
        """Update an existing Market  # noqa: E501

        Update information about a Market.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_market(market_id, market_update, async_req=True)
        >>> result = thread.get()

        Args:
            market_id (int):
            market_update (MarketUpdate):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Market
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['market_id'] = \
            market_id
        kwargs['market_update'] = \
            market_update
        return self.update_market_endpoint.call_with_http_info(**kwargs)

